package com.simonstl.midp.xml;

/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

import java.util.Vector;
import com.simonstl.midp.tam.*; 

/**
 *
 * An implementation of {@link com.simonstl.midp.tam.TamAttributes TamAttributes},
 * used by {@link com.simonstl.midp.xml.TAMParserImpl TAMParserImpl} to report
 * attributes.
 *
 * @author  simonstl
 */
public class TAMAttributesImpl implements TamAttributes {
    
    Vector attributes=new Vector();
    
    /** Creates a new instance of TAMAttributesImpl */
    public TAMAttributesImpl() {
        
    }
    
    public TAMAttributesImpl(TamAttributes atts) {
        
    }
    
    public int getIndex(String uri, String localName) {
        int size=attributes.size();
        int result=-1;
        for (int i=0; i<size; i++) {
            TAMAttribute att=(TAMAttribute) attributes.elementAt(i);
            if ( (att.getUri().equals(uri)) && (att.getLocalName().equals(localName)) ) {
              result=i;
              i=size;
            }
        }
        return result;
    }
    
    public int getLength() {
        return attributes.size();
    }
    
    public String getLocalName(int index) {
        TAMAttribute att=(TAMAttribute) attributes.elementAt(index);
        return att.getLocalName();
    }
    
    public String getQName(int index) {
        TAMAttribute att=(TAMAttribute) attributes.elementAt(index);
        return att.getQName();
    }
    
    public String getPrefix(int index) {
        TAMAttribute att=(TAMAttribute) attributes.elementAt(index);
        return att.getPrefix();
    }
    
    public String getUri(int index) {
        TAMAttribute att=(TAMAttribute) attributes.elementAt(index);
        return att.getUri();
    }
    
    public String getValue(int index) {
        TAMAttribute att=(TAMAttribute) attributes.elementAt(index);
        return att.getValue();
    }
    
    public String getValue(String uri, String localName) {
        int index=getIndex(uri, localName);
        String result=null;
        if (index>-1) {
          result=getValue(index);   
        }
        
        return result;
    }
    
    public void addAttribute(java.lang.String uri, java.lang.String localName, java.lang.String prefix, 
           java.lang.String value) {
        TAMAttribute adder=new TAMAttribute();
        adder.setUri(uri);
        adder.setLocalName(localName);
        adder.setPrefix(prefix);
        adder.setValue(value);
        
        attributes.addElement(adder);
    }
    
    public void addAttribute(TAMAttribute adder) {
        attributes.addElement(adder);
    }
    
    public boolean getContainsSkippedEntity(int index) {
        TAMAttribute att=(TAMAttribute) attributes.elementAt(index);
        return att.getContainsSkippedEntity(); 
    }
    
    public boolean getContainsSkippedEntity(String uri, String localName) {
        int index=getIndex(uri, localName);
        boolean contains=false;
        if (index>-1) {
          contains=getContainsSkippedEntity(index);   
        }
        return contains;
    }
    
    public void setUris(TAMNSContext namespaces){
//System.out.println("Setting attribute namespaces");
        int size=attributes.size();
        
        for (int i=0; i<size; i++) {
            TAMAttribute att=(TAMAttribute) attributes.elementAt(i);
            String prefix=att.getPrefix();
//System.out.println("Prefix is:"+prefix);
            if (prefix.equals("xmlns")){
                att.setUri("http://www.w3.org/TR/REC-xml-names/");
            } else {
                if (prefix.equals("")){
                    att.setUri("");
                } else {
                    att.setUri(namespaces.getUri(prefix));
                }
            }
//System.out.println("Result is:"+att.getUri());
        }
        
    }
}
