/*
 * TAMElement.java
 *
 * Created on July 27, 2002, 11:37 AM
 */

package com.simonstl.midp.xml;
import com.simonstl.midp.tam.*; 
/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
 *
 * A simple extension of {@link com.simonstl.midp.xml.TAMName TAMName} which can
 * hold and manipulate attributes as well as keep track if the element is empty.
 *
 * @author  simonstl
 */
public class TAMElement extends TAMName {
    
    protected TAMAttributesImpl attributes=new TAMAttributesImpl();
    protected boolean isEmpty=false;
    
    /** Creates a new instance of TAMElement */
    public TAMElement() { 
    }
    
    public void addAttribute(TAMAttribute att){
      attributes.addAttribute(att);   
    }
    
    public void setAttUris(TAMNSContext namespaces){
        attributes.setUris(namespaces);
    }
    
    public TamAttributes getAttributes(){
      return attributes;
    }
    
    public void setIsEmpty (boolean _empty){
      isEmpty=_empty;   
    }
    
    public boolean getIsEmpty(){
        return isEmpty;    
    }
}
