package com.simonstl.midp.xml;


/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* Derived from com.simonstl.moe.NamespaceDecl.
*
 * This class stores namespace declaration information.
 *
* @version 0.01 12 August 2002
* @author Simon St.Laurent
**/

public class TAMNSName extends TAMAttribute {

/**level is used by {@link com.simonstl.midp.xml.TAMNSContext TAMNSContext } to determine where in a tree a given namespace applies.
**/

protected int level;
/**current indicates that a namespace needs to be declared in the current context.  If events came through a SAX filter stripping xmlns attributes, this is useful.
**/

protected boolean current;

/** Prefix for namespaces is always xmlns.
**/

public String getPrefix() {
   return "xmlns";
}
/** Attempts to set prefixes on namespace names will be ignored.
**/

public void setPrefix(String prefix){

}

public String getUri() {
   return "http://www.w3.org/TR/REC-xml-names/";
}

public void setUri(String nsURI){

}

public String getLocalName() {
   return name;
}
/**
Use setLocalName to identify the namespace prefix being used.
**/
public void setLocalName(String _localName){
   name=_localName;
}


/**
* Returns the Qualified Name (QName) for the component. Overrides the usual
* QName approach because of the different approach used by Namespaces in XML.
**/
public String getQName(){
   String returnVal="xmlns";

   if (!name.equals("")) {
    returnVal=returnVal+":"+name;
   }
   return returnVal;
}


/**
* getLevel()is used by the {@link com.simonstl.midp.xml.TAMNSContext TAMNSContext} object to figure out which declarations appeared where.
**/
public int getLevel(){
   return level;
}
/**
* setLevel()is used by the {@link com.simonstl.midp.xml.TAMNSContext TAMNSContext} object to establish which declarations appeared where.
**/
public void setLevel(int _level){
   level=_level;
}



}